program minimal_model
implicit none
include 'mpif.h'
!the dimension of the state vector is hard coded as 20 here
real(kind=kind(1.0D0)), dimension(20) :: state_vector
integer :: iteration

!declarations to initialise EMPIRE coupling
integer :: mpi_err,world_size,world_id
integer :: cpl_mpi_comm,cpl_root,cpl_colour
integer :: particle_id,nens, da, nda
integer :: mdl_num_proc,mdl_id,mdl_mpi_comm,mdlcolour
integer :: tmp_mdls_comm,models_id,models_size

!declarations for mpi_send/mpi_recv communications
integer :: tag
integer :: mpi_status(MPI_STATUS_SIZE)

call mpi_init(mpi_err)
mdl_num_proc = 4
da = 0
call mpi_comm_rank (MPI_COMM_WORLD,world_id,mpi_err)
call mpi_comm_size (MPI_COMM_WORLD,world_size,mpi_err)
call mpi_comm_split(MPI_COMM_WORLD,da,world_id,tmp_mdls_comm,mpi_err)
call mpi_comm_size (tmp_mdls_comm,models_size,mpi_err)
call mpi_comm_rank (tmp_mdls_comm,models_id,  mpi_err)
mdlcolour = models_id/mdl_num_proc
call mpi_comm_split(tmp_mdls_comm,mdlcolour,models_id,mdl_mpi_comm,mpi_err)
call mpi_comm_rank (mdl_mpi_comm,mdl_id,mpi_err)
if(mdl_id .eq. 0) then
   cpl_colour = 9999
else
   cpl_colour = MPI_UNDEFINED
end if
call mpi_comm_split(MPI_COMM_WORLD,cpl_colour,mdlcolour,cpl_mpi_comm,mpi_err)
if(mdl_id .eq. 0) then
   call mpi_comm_size(cpl_mpi_comm,nens,mpi_err)
   call mpi_comm_rank(cpl_mpi_comm,particle_id,mpi_err)
   nda = world_size-models_size;nens = nens - nda
   cpl_root = (nda*particle_id/nens)+nens
else
   cpl_root = -1
end if



state_vector = 1.0d0
tag=1

print*,'MINIMAL MODEL: Global id = ',world_id
print*,'MINIMAL MODEL: Model id = ',mdl_id,' with model communicator&
     & ',mdl_mpi_comm
if(mdl_id .eq. 0) then 
   print*,'MINIMAL MODEL: as model id = 0 we have particle_id&
     & = ',particle_id
   print*,'MINIMAL MODEL: the cpl_root is',cpl_root
end if

if(mdl_id .eq. 0) then
call mpi_send(state_vector,20,MPI_DOUBLE_PRECISION,cpl_root&
     &,tag,cpl_mpi_comm,mpi_err)
call mpi_recv(state_vector,20,MPI_DOUBLE_PRECISION,cpl_root&
     &,MPI_ANY_TAG,cpl_mpi_comm,mpi_status,mpi_err)
end if

!the number of iterations given here must correspond to 
!the number of iterations listed in the particle filter code
do iteration =1,40
   state_vector = 1.5D0*state_vector

   if(mdl_id .eq. 0) then
      call mpi_send(state_vector,20,MPI_DOUBLE_PRECISION,cpl_root&
           &,tag,cpl_mpi_comm,mpi_err)
      call mpi_recv(state_vector,20,MPI_DOUBLE_PRECISION,cpl_root&
           &,MPI_ANY_TAG,cpl_mpi_comm,mpi_status,mpi_err)
   end if
   
   if(mdl_id .eq. 0) then
      print*,iteration,state_vector(1)
   end if
   
end do
call mpi_finalize(mpi_err)

end program minimal_model
